# -*- coding: iso-8859-1 -*-
#
# Permanent Recording Plugin by gutemine
#
permanentrecording_version="1.2.3"
#
from RecordTimer import parseEvent, RecordTimerEntry
from Plugins.Plugin import PluginDescriptor
from Components.config import config, ConfigSubsection, ConfigEnableDisable, ConfigInteger
from enigma import eTimer,  eServiceReference, eServiceCenter, iServiceInformation, eEPGCache
from Screens.Screen import Screen
from Components.ConfigList import ConfigListScreen
from Screens.Setup import SetupSummary
from Components.ActionMap import ActionMap
from Components.config import config, getConfigListEntry
from Components.Label import Label
from Screens.Console import Console
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Screens.TimerSelection import TimerSelection
from ServiceReference import ServiceReference
from Screens.InfoBar import MoviePlayer
from Screens.InfoBarGenerics import InfoBarSeek
from time import time, localtime, strftime

import Screens.Standby
import gettext
import os
global permanentrecording_serviceref
permanentrecording_serviceref=""
global permanentrecording_begin_time
global permanentrecording_end_time
permanentrecording_begin_time=0
permanentrecording_end_time=0
global permanentrecording_keep
permanentrecording_keep=False
global permanentrecording_extend
permanentrecording_extend=False

permanentrecording_plugindir="/usr/lib/enigma2/python/Plugins/Extensions/PermanentRecording"
# check diskspace and recordingfiles every 5min - change only for debugging
permanentrecording_housekeeping=300
permanentrecording_bytes2gb=1024*1024*1024

# add local language file

os.environ['LANGUAGE']='en'
permanentrecording_language='en'

if os.path.exists("/etc/enigma2/settings") == True:
   f = open("/etc/enigma2/settings")
   line = f.readline()
   while (line):
	line = f.readline().replace("\n","")
	sp = line.split("=")
	if (sp[0] == "config.osd.language"):
	   sp2 = sp[1].split("_")
           permanentrecording_language = sp2[0]
           if os.path.exists("%s/locale/%s" % (permanentrecording_plugindir, permanentrecording_language)) == True:
              os.environ["LANGUAGE"] = sp[1]
           else:
              os.environ['LANGUAGE']='en'
              permanentrecording_language='en'
   f.close

if os.path.exists("%s/locale/%s" % (permanentrecording_plugindir,permanentrecording_language)):
   _=gettext.Catalog('pr', "%s/locale" % permanentrecording_plugindir).gettext

config.plugins.permanentrecording = ConfigSubsection()
config.plugins.permanentrecording.enabled = ConfigEnableDisable(default = False)
config.plugins.permanentrecording.perevent = ConfigEnableDisable(default = True)
config.plugins.permanentrecording.extralocation = ConfigEnableDisable(default = False)
config.plugins.permanentrecording.kickstart = ConfigEnableDisable(default = True)
config.plugins.permanentrecording.viewingtime = ConfigInteger(default = 5, limits = (2, 60))
config.plugins.permanentrecording.maxdiskspace = ConfigInteger(default = 10, limits = (5, 100))
config.plugins.permanentrecording.maxrecordings = ConfigInteger(default = 10, limits = (5, 100))
config.plugins.permanentrecording.duringstandby = ConfigEnableDisable(default = False)
config.plugins.permanentrecording.timercleanup = ConfigEnableDisable(default = False)
config.plugins.permanentrecording.useplayer = ConfigEnableDisable(default = True)
config.plugins.permanentrecording.jumptoend = ConfigEnableDisable(default = True)
config.plugins.permanentrecording.timerhide = ConfigEnableDisable(default = True)
config.plugins.permanentrecording.shutdownhide = ConfigEnableDisable(default = True)

if not os.path.exists("/media/hdd/movie/pr"):
   os.mkdir("/media/hdd/movie/pr")
   
def autostart(reason, **kwargs):
    global session
    if kwargs.has_key("session") and reason == 0:
       session = kwargs["session"]
       print "[PR] autostart check"
       session.open(PermanentRecordingCheck)
    if kwargs.has_key("session") and reason == 1:
       session = kwargs["session"]
       session.open(PermanentRecordingStop)

def Plugins(**kwargs):
    return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),
    		PluginDescriptor(name=_("Permanent Recording"), description=_("Big Brother is watching you"), where = PluginDescriptor.WHERE_PLUGINMENU, icon="hal.png", fnc=main),
		PluginDescriptor(name=_("Permanent Recording"), description=_("Big Brother is watching you"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, icon="hal.png", fnc=main)]


def main(session, **kwargs):
        print "[PR] Open Config Screen"
        session.open(PermanentRecordingConfiguration)

class PermanentRecordingConfiguration(Screen, ConfigListScreen):
    skin = """
        <screen position="100,100" size="550,440" title="Permanent Recording" >
        <widget name="config" position="0,0" size="550,400" scrollbarMode="showOnDemand" />
        <widget name="buttonred" position="10,400" size="100,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        <widget name="buttongreen" position="120,400" size="100,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        <widget name="buttonyellow" position="230,400" size="100,40" backgroundColor="yellow" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        <widget name="buttonblue" position="340,400" size="100,40" backgroundColor="blue" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        </screen>"""

    def __init__(self, session, args = 0):
	Screen.__init__(self, session)
       	self.list = []
        self.list.append(getConfigListEntry(_("Enable permanent recording"), config.plugins.permanentrecording.enabled))
        self.list.append(getConfigListEntry(_("Use Media Player to play permanent recordings"), config.plugins.permanentrecording.useplayer))
        self.list.append(getConfigListEntry(_("Jump to end on playing"), config.plugins.permanentrecording.jumptoend))
        self.list.append(getConfigListEntry(_("Add recording per event"), config.plugins.permanentrecording.perevent))
        self.list.append(getConfigListEntry(_("Permanent Recordings at /media/hdd/movie/pr"), config.plugins.permanentrecording.extralocation))
        self.list.append(getConfigListEntry(_("Record after viewing for 2-60 seconds"), config.plugins.permanentrecording.viewingtime))
        self.list.append(getConfigListEntry(_("Kickstart when tuner busy"), config.plugins.permanentrecording.kickstart))
        self.list.append(getConfigListEntry(_("Maximal diskspace from 5-100 GB"), config.plugins.permanentrecording.maxdiskspace))
        self.list.append(getConfigListEntry(_("Maximal number of recordings 5-100"), config.plugins.permanentrecording.maxrecordings))
        self.list.append(getConfigListEntry(_("Continue recording also during Standby"), config.plugins.permanentrecording.duringstandby))
        self.list.append(getConfigListEntry(_("Enable permanent timer cleanup"), config.plugins.permanentrecording.timercleanup))
        self.list.append(getConfigListEntry(_("Hide permanent recording timer"), config.plugins.permanentrecording.timerhide))
        self.list.append(getConfigListEntry(_("Hide shutdown question"), config.plugins.permanentrecording.shutdownhide))
        # dirty, I know
        try:        
           self.list.append(getConfigListEntry(_("Show blinking clock in display during recording"), config.usage.blinking_display_clock_during_recording))
           self.list.append(getConfigListEntry(_("Show Message when Recording starts"), config.usage.show_message_when_recording_starts))
        except:
           pass
        self.onShown.append(self.setWindowTitle)
       	ConfigListScreen.__init__(self, self.list)

        # explizit check on every entry
	self.onChangedEntry = []

       	self["buttonred"] = Label(_("Cancel"))
       	self["buttongreen"] = Label(_("OK"))
        if config.plugins.permanentrecording.enabled.value:
       	   self["buttonyellow"] = Label(_("Keep"))
        else:
       	   self["buttonyellow"] = Label(_("Delete"))
       	self["buttonblue"] = Label(_("Check"))
        self["setupActions"] = ActionMap([ "ColorActions", "SetupActions" ],
       	{
       		"green": self.save,
        	"red": self.cancel,
        	"yellow": self.remove,
        	"blue": self.used,
            	"save": self.save,
            	"cancel": self.cancel,
            	"ok": self.save,
       	})
    def setWindowTitle(self):
        self.setTitle(_("Permanent Recording Version %s") % permanentrecording_version)

    def save(self):
        for x in self["config"].list:
           x[1].save()
        self.close(True)

    def cancel(self):
        for x in self["config"].list:
           x[1].cancel()
        self.close(False)

    def used(self):
        for x in self["config"].list:
           x[1].save()
        diskspace=0
        recordingfiles=0
        if config.plugins.permanentrecording.extralocation.value:
           permanentrecording_movie_path="/media/hdd/movie/pr/"
        else:
           permanentrecording_movie_path="/media/hdd/movie/"
        for filename in os.listdir(permanentrecording_movie_path):
           if filename.find("[PR]") is not -1 and filename.endswith(".ts"):
              diskspace=diskspace+os.path.getsize("%s/%s" % (permanentrecording_movie_path,filename))
              recordingfiles=recordingfiles+1
        diskspace=int(diskspace/permanentrecording_bytes2gb)
        maxdiskspace=config.plugins.permanentrecording.maxdiskspace.value
        maxrecordings=config.plugins.permanentrecording.maxrecordings.value
        self.session.open(MessageBox,_("You have used %i GB from maximum %i GB\nby %i files from maximum %i files") % (diskspace,maxdiskspace,recordingfiles,maxrecordings), MessageBox.TYPE_INFO,timeout=10)
 
    def remove(self):
        global permanentrecording_keep
        for x in self["config"].list:
           x[1].save()
        if config.plugins.permanentrecording.enabled.value:
	   permanentrecording_keep=True
	   
           if config.plugins.permanentrecording.extralocation.value:
              permanentrecording_movie_path="/media/hdd/movie/pr/"
           else:
              permanentrecording_movie_path="/media/hdd/movie/"
           newestdatum=0
           newestrecord="permanentrecord_dummy"
           for filename in os.listdir(permanentrecording_movie_path):
              if filename.find("[PR]") is not -1 and filename.endswith(".ts"):
                 sp=filename.split(" ")
                 datum=int("%s%s" % (sp[0],sp[1]))
                 if newestdatum==0:
                    newestdatum=datum
                    newestrecord=filename
                 if datum >= newestdatum:
                    newestdatum=datum
                    newestrecord=filename
           if os.path.exists("%s/%s" % (permanentrecording_movie_path,newestrecord)):
              newestrecordmeta="%s.meta" % newestrecord
              saverecord=newestrecord.replace("[PR]","")
              saverecordmeta="%s.meta" % saverecord
              os.link("%s/%s" % (permanentrecording_movie_path,newestrecord), "%s/%s" % (permanentrecording_movie_path,saverecord))
              os.link("%s/%s" % (permanentrecording_movie_path,newestrecordmeta), "%s/%s" % (permanentrecording_movie_path,saverecordmeta))
           self.session.open(MessageBox,_("Current Permanent Recording will be kept on zapping"), MessageBox.TYPE_INFO)
        else:
           self.session.openWithCallback(self.RemovePermanentRecordings,MessageBox,_("Sure to remove ALL permanent recordings ?"), MessageBox.TYPE_YESNO)

    def RemovePermanentRecordings(self,answer):
        if answer is None:
            self.skipRemove(_("answer is None"))
        elif answer is False:
            self.skipRemove(_("you were not confirming"))
        else:
           # dirty I know, but Housekeeping has to be made more clever .. later
           if config.plugins.permanentrecording.extralocation.value:
              permanentrecording_movie_path="/media/hdd/movie/pr/"
           else:
              permanentrecording_movie_path="/media/hdd/movie/"
           for filename in os.listdir(permanentrecording_movie_path):
              # for compatibility reason
              if filename.find("Permanent Recording") is not -1:
                 os.remove("%s/%s" % (permanentrecording_movie_path,filename))
              if filename.find("[PR]") is not -1:
                 os.remove("%s/%s" % (permanentrecording_movie_path,filename))
           self.session.open(MessageBox,_("Remove of Permanent Recordings completed !"), MessageBox.TYPE_INFO,timeout=10)
            
    def skipRemove(self,reason):
        self.session.open(MessageBox,_("Removing of Permanent Recordings was canceled, because %s") % reason, MessageBox.TYPE_WARNING)


    def check(self):
        for x in self["config"].list:
           x[1].cancel()
        self.close(False)

class PermanentRecordingCheck(Screen):
    skin = """
        <screen position="150,100" size="400,300" title="Permanent Recording Check" >
        </screen>"""
    def __init__(self,session):
        self.skin = PermanentRecordingCheck.skin
	self.session = session
        self.permanentrecording = []
	Screen.__init__(self,session)
        print "[PR] planning periodic checks"
        self.TimerPermanentRecordingCheck = eTimer()
        self.TimerPermanentRecordingCheck.stop()
        self.TimerPermanentRecordingCheck.timeout.get().append(self.CheckPermanentRecording)
        # first start is after 30 sec so that EPG is filled for timer event
        self.TimerPermanentRecordingCheck.start(30000,True) 
        self.TimerPermanentRecordingHousekeeping = eTimer()
        self.TimerPermanentRecordingHousekeeping.stop()
        self.TimerPermanentRecordingHousekeeping.timeout.get().append(self.HousekeepingPermanentRecording)
        self.TimerPermanentRecordingHousekeeping.start(permanentrecording_housekeeping*1000,True) 

    def CheckPermanentRecording(self):
        global permanentrecording_serviceref
        global permanentrecording_begin_time
        global permanentrecording_end_time
        global permanentrecording_extend
        self.TimerPermanentRecordingCheck.stop()
        if config.plugins.permanentrecording.timercleanup.value:
           self.session.nav.RecordTimer.cleanup()
        servref = self.session.nav.getCurrentlyPlayingServiceReference()
        if servref is None:
           # let's say a None service ref is non-Live TV
           serviceref="1:0:0:0:0:0:0:0:0:0"
        else:
           serviceref = servref.toString()
            
#       print("[PR] serviceref: %s" %serviceref)
        if Screens.Standby.inStandby and config.plugins.permanentrecording.duringstandby.value is not True:
           permanentrecording_extend=False
           # in standby, so let's stop the permanent recording
           if self.isPermanentRecordRunning() is True:
              # reset serveref so that recording will start again when standby is left
              permanentrecording_serviceref=""
              if permanentrecording_extend:
                 permanentrecording_extend=False
              list=((_("stop recording"), "stop"))
              try:
                 self.permanentrecordQuestionCallback(list)
              except:
                 pass
        else:
           if config.plugins.permanentrecording.enabled.value:
              if not serviceref.startswith("1:0:0:0:0:0:0:0:0:0"):
                 # reset extend if watching Live TV again
                 if permanentrecording_extend:
                    permanentrecording_extend=False
                 # new check
                 service = self.session.nav.getCurrentService()
                 info = service and service.info()
                 ptr = info and info.getEvent(0)
                 begin_time = ptr and ptr.getBeginTime() or 0
                 # EPG event needs some time to load, so keep value until new one is available
                 if permanentrecording_begin_time==0 and begin_time > 0:
                    permanentrecording_begin_time=begin_time
                 if begin_time==0 and permanentrecording_begin_time > 0:
                    permanentrecording_begin_time=begin_time
                 # Zapping check 
#                print("[PR] serviceref: %s begin time: %i previous time: %i" %(serviceref,begin_time,permanentrecording_begin_time))
                 if (serviceref != permanentrecording_serviceref) or (begin_time != permanentrecording_begin_time and config.plugins.permanentrecording.perevent.value):
                    print("[PR] zapped to serviceref: %s or new begin time: %i" %(serviceref,begin_time))
                    permanentrecording_serviceref=serviceref
                    permanentrecording_begin_time=begin_time
                    # zapped away, or new begin time so let's stop the permanent recording if running
                    if self.isPermanentRecordRunning() is True:
                       list=((_("stop recording"), "stop"))
                       try:
                          self.permanentrecordQuestionCallback(list)
                       except:
                          pass
                    # Kickstarter
                    # on a single or locked tuner this helps a lot ...
                    if config.plugins.permanentrecording.kickstart.value:
                       service = self.session.nav.getCurrentService()
                       info = service and service.info()
                       error = info and info.getInfo(iServiceInformation.sDVBState)
#                      print("[PR] error %i" %error)
                       if error == 0:
                          self.session.nav.stopService()
                          self.session.nav.playService(servref)
                    # if permanent rercording is enabled start it 
                    # if no permanent recording is running and we watch live TV !
                    if self.isPermanentRecordRunning() is False:
                       if config.plugins.permanentrecording.perevent.value:
                          list=((_("add recording (stop after current event)"), "event"))
                       else:
                          list=((_("add recording (indefinitely)"), "indefinitely"))
                       try:
                          self.permanentrecordQuestionCallback(list)
                       except:
                          pass
              else:
                 # if we are not watching live TV we have to extend  the timer
                 if config.plugins.permanentrecording.perevent.value and not permanentrecording_extend and config.plugins.permanentrecording.enabled.value and not config.plugins.permanentrecording.duringstandby.value:
                    permanentrecording_extend=True
		    self.extendCurrentRecording(0)
           else:
              permanentrecording_extend=False
              # reset serveref so that recording will start again when enabled
              permanentrecording_serviceref=""
              # disabled, so let's stop the permanent recording if it is runnign
              if self.isPermanentRecordRunning() is True:
                 list=((_("stop recording"), "stop"))
                 try:
                    self.permanentrecordQuestionCallback(list)
                 except:
                    pass
        self.TimerPermanentRecordingCheck.start(config.plugins.permanentrecording.viewingtime.value*1000,True) 
        
    def stopCurrentRecording(self, entry = -1):
        global permanentrecording_keep
	if entry is not None and entry != -1:
	   if not permanentrecording_keep:
	      self.session.nav.RecordTimer.removeEntry(self.permanentrecording[entry])
	   else:
	      permanentrecording_keep=False
	   self.permanentrecording.remove(self.permanentrecording[entry])
        
    def extendCurrentRecording(self, entry = -1):
	if entry is not None and entry != -1:
	   # dirty, I know
	   try:
              self.permanentrecording[entry].autoincrease=True
              self.permanentrecording[entry].setAutoincreaseEnd()
              self.session.nav.RecordTimer.timeChanged(self.permanentrecording[entry])
           except:
              pass

    def startPermanentRecording(self, limitEvent = False):
        global permanentrecording_end_time
	serviceref = self.session.nav.getCurrentlyPlayingServiceReference()

	# try to get event info
	event = None
	try:
                service = self.session.nav.getCurrentService()
		epg = eEPGCache.getInstance()
		event = epg.lookupEventTime(serviceref, -1, 0)
		if event is None:
			info = service.info()
			ev = info.getEvent(0)
			event = ev
	except:
		pass

	begin = int(time())
	end = begin + 3600	# dummy
	name = "[PR]"
	description = ""
	eventid = None

	if event is not None:
		curEvent = parseEvent(event)
		name = "[PR] %s" % curEvent[2]
		description = curEvent[3]
		eventid = curEvent[4]
		if limitEvent:
			end = curEvent[1]

	if isinstance(serviceref, eServiceReference):
		serviceref = ServiceReference(serviceref)

        if config.plugins.permanentrecording.extralocation.value:
           permanentrecording_movie_path="/media/hdd/movie/pr/"
        else:
           permanentrecording_movie_path="/media/hdd/movie/"
        recording = RecordTimerEntry(serviceref, begin, end, name, description, eventid, dirname = permanentrecording_movie_path)
	recording.dontSave = True
	permanentrecording_end_time=end
	
		
	if event is None or limitEvent == False:
		recording.autoincrease = True
		# just a dummy time 100h in the Future
       	        permanentrecording_end_time=end+3600*100
		if recording.setAutoincreaseEnd():
			self.session.nav.RecordTimer.record(recording)
			self.permanentrecording.append(recording)
	else:
			simulTimerList = self.session.nav.RecordTimer.record(recording)
			if simulTimerList is not None:	# conflict with other recording
				name = simulTimerList[1].name
				name_date = ' '.join((name, strftime('%c', localtime(simulTimerList[1].begin))))
				print "[TIMER] conflicts with", name_date
				recording.autoincrease = True	# start with max available length, then increment
				if recording.setAutoincreaseEnd():
					self.session.nav.RecordTimer.record(recording)
					self.permanentrecording.append(recording)
					self.session.open(MessageBox, _("Record time limited due to conflicting timer %s") % name_date, MessageBox.TYPE_INFO)
				recording.autoincrease = False
			else:
				self.permanentrecording.append(recording)

    def isPermanentRecordRunning(self):
	if self.permanentrecording:
		for x in self.permanentrecording:
			if x.isRunning():
				return True
	return False

    def permanentrecordQuestionCallback(self, answer):
	if answer is None or answer[1] == "no":
		return
	list = []
	recording = self.permanentrecording[:]
	for x in recording:
		if not x in self.session.nav.RecordTimer.timer_list:
			self.permanentrecording.remove(x)
		elif x.dontSave and x.isRunning():
			list.append((x, False))

	if answer[1] == "stop":
		if len(self.permanentrecording) == 1:
			self.stopCurrentRecording(0)
		else:
			self.session.openWithCallback(self.stopCurrentRecording, TimerSelection, list)
	elif answer[1] in ( "indefinitely" , "event"):
		self.startPermanentRecording(limitEvent = answer[1] in ("event", "manualendtime") or False)

    def HousekeepingPermanentRecording(self):
        self.TimerPermanentRecordingHousekeeping.stop()
        diskspace=0
        recordingfiles=0
        maxdiskspace=config.plugins.permanentrecording.maxdiskspace.value*permanentrecording_bytes2gb
        if config.plugins.permanentrecording.enabled.value:
           # if no recordings during standby and we are in standby housekeeping is not needed
           if (Screens.Standby.inStandby and config.plugins.permanentrecording.duringstandby.value is not True) or not self.isPermanentRecordRunning():
              self.TimerPermanentRecordingHousekeeping.start(permanentrecording_housekeeping*1000,True) 
              return
           if config.plugins.permanentrecording.extralocation.value:
              permanentrecording_movie_path="/media/hdd/movie/pr/"
           else:
              permanentrecording_movie_path="/media/hdd/movie/"
           for filename in os.listdir(permanentrecording_movie_path):
              if filename.find("[PR]") is not -1 and filename.endswith(".ts"):
#                print "[PR] %s" %(filename)
                 diskspace=diskspace+os.path.getsize("%s/%s" % (permanentrecording_movie_path,filename))
                 recordingfiles=recordingfiles+1
           print "[PR] recordings: %i diskspace used: %i max diskspace: %i" %(recordingfiles,diskspace,maxdiskspace)
           # prevent that a single file fills up the whole allowed space
           if self.isPermanentRecordRunning() and recordingfiles < 2 and diskspace > (maxdiskspace/2):
              print "[PR] found too few too big recordings, restarting"
              list=((_("stop recording"), "stop"))
              try:
                 self.permanentrecordQuestionCallback(list)
              except:
                 pass
              # restart immediately
              if config.plugins.permanentrecording.perevent.value:
                 list=((_("add recording (stop after current event)"), "event"))
              else:
                 list=((_("add recording (indefinitely)"), "indefinitely"))
              try:
                 self.permanentrecordQuestionCallback(list)
              except:
                 pass
           # check if it is time for cleaning 
           while ((diskspace > maxdiskspace) or (recordingfiles >= config.plugins.permanentrecording.maxrecordings.value)) and (recordingfiles > 1):
#             print "[PR] removing old recordings"
              # first find oldest recording
              oldestdatum=0
              oldestrecord="permanentrecord_dummy"
              for filename in os.listdir(permanentrecording_movie_path):
                 if filename.find("[PR]") is not -1 and filename.endswith(".ts"):
                    sp=filename.split(" ")
                    datum=int("%s%s" % (sp[0],sp[1]))
#                   print "[PR] datum %i" %(datum)
                    if oldestdatum==0:
                       oldestdatum=datum
                       oldestrecord=filename
                    if datum < oldestdatum:
                       oldestdatum=datum
                       oldestrecord=filename
#                      print "[PR] older record %i %s" %(oldestdatum, oldestrecord)
              print "[PR] removing oldest record %i %s" %(oldestdatum, oldestrecord)
              if os.path.exists("%s/%s" % (permanentrecording_movie_path,oldestrecord)):
                 shortfilename=oldestrecord.replace(".ts","")
                 diskspace=diskspace-os.path.getsize("%s/%s" % (permanentrecording_movie_path,oldestrecord))
                 recordingfiles=recordingfiles-1
                 print "[PR] removing %s.*" %(shortfilename)
                 print "[PR] current diskspace used %i max diskspace %i" %(diskspace,maxdiskspace)
                 for removefilename in os.listdir(permanentrecording_movie_path):
                    if removefilename.startswith(shortfilename):
                       if os.path.exists("%s/%s" % (permanentrecording_movie_path,removefilename)):
                          os.remove("%s/%s" % (permanentrecording_movie_path,removefilename))
      
        self.TimerPermanentRecordingHousekeeping.start(permanentrecording_housekeeping*1000,True) 

		
class PermanentRecordingStop(Screen):
    skin = """
        <screen position="150,100" size="400,300" title="Permanent Recording Stop" >
        </screen>"""
    def __init__(self,session):
        self.skin = PermanentRecordingCheck.skin
	self.session = session
        self.permanentrecording = []
	Screen.__init__(self,session)
        print "[PR] stopping periodic check and timers"
        self.TimerPermanentRecordingCheck.stop()
        if config.plugins.permanentrecording.timercleanup.value:
           self.session.nav.RecordTimer.cleanup()

        self.TimerPermanentRecordingCheck.stop()
        servref = self.session.nav.getCurrentlyPlayingServiceReference()
#       print("[PR] serviceref: %s" %serviceref)
        if config.plugins.permanentrecording.enabled.value is True:
           if self.isPermanentRecordRunning() is True:
              list=((_("stop recording"), "stop"))
              try:
                 self.permanentrecordQuestionCallback(list)
              except:
                 pass

class PermanentRecordingPlay(InfoBarSeek):
	def __init__(self,session):
                self.session=session
                if config.plugins.permanentrecording.extralocation.value:
                   permanentrecording_movie_path="/media/hdd/movie/pr/"
                else:
                   permanentrecording_movie_path="/media/hdd/movie/"
                newestdatum=0
                newestrecord="permanentrecord_dummy"
                for filename in os.listdir(permanentrecording_movie_path):
                   if filename.find("[PR]") is not -1 and filename.endswith(".ts"):
                      sp=filename.split(" ")
                      datum=int("%s%s" % (sp[0],sp[1]))
                      if newestdatum==0:
                         newestdatum=datum
                         newestrecord=filename
                      if datum >= newestdatum:
                         newestdatum=datum
                         newestrecord=filename
                if os.path.exists("%s/%s" % (permanentrecording_movie_path,newestrecord)):
                   from Screens.InfoBar import MoviePlayer
                   ref = eServiceReference(1, 0, "%s/%s" % (permanentrecording_movie_path,newestrecord))     
                   if config.plugins.permanentrecording.useplayer.value:
                      self.session.open(MoviePlayer,ref)
                   else:
                      self.session.nav.playService(ref)
                   if config.plugins.permanentrecording.jumptoend.value:
                      self.doSeek(-5)
